// #autoload
// #name = WheelZoom
// #version = 1.0
// #date = March 1, 2003
// #status = beta
// #author = ilys
// #warrior = ilys
// #description = MouseWheel Zooming
// #category = ilys' Scripts
// #config = WheelZoomOptions

$WheelZoom::invertzoom = "0";

if(!isFile("prefs/wheelzoomprefs.cs"))
	export("$WheelZoom::*", "prefs/wheelzoomprefs.cs", false);
exec("prefs/wheelzoomprefs.cs");

function WheelZoomZoomAxis(%inc)
{
	%inc = mCeil(%inc / 120);
	if($WheelZoom::invertzoom)
	{
		for(%i = 0; %i > %inc; %i--)
			$pref::player::currentFOV /= 2.5;
		for(%i = 0; %i < %inc; %i++)
			$pref::player::currentFOV *= 2.5;
	}
	else
	{
		for(%i = 0; %i < %inc; %i++)
			$pref::player::currentFOV /= 2.5;
		for(%i = 0; %i > %inc; %i--)
			$pref::player::currentFOV *= 2.5;
	}

	if($pref::player::currentFOV > 50)
		$pref::player::currentFOV = 50;
	else if($pref::player::currentFOV < 5)
		$pref::player::currentFOV = 5;

	if($ZoomOn)
		setFOV($pref::player::currentFOV);
}

package WheelZoom
{
	function toggleZoom(%keydown)
	{
		parent::toggleZoom(%keydown);

		if($ZoomON)
		{
			if(!isObject(WheelZoomMap))
			{
				new ActionMap(WheelZoomMap);
				WheelZoomMap.bind(mouse0, zaxis, WheelZoomZoomAxis);
			}
			WheelZoomMap.push();
		}

		if(!$ZoomON)
		{
			if(isObject(WheelZoomMap))
				WheelZoomMap.pop();
		}
	}
	function WheelZoomOptions::OnWake()
	{
//		No console spam please
	}
	function WZSaveSettings()
	{
		export("$WheelZoom::*", "prefs/wheelzoomprefs.cs", false);
	}
	function setUnZoom(%val)
	{
		if(%val && $ZoomOn) toggleZoom(1);
	}
	function OptionsDlg::onWake(%this)
	{
		if(!$ZoomTestKeys)
		{
			$RemapName[$RemapCount]="Unzoom";
			$RemapCmd[$RemapCount]="setUnZoom";
			$RemapCount++;
			$ZoomTestKeys = 1;
		}
		parent::onWake(%this);
	}
};

activatePackage(WheelZoom);

new GuiControl(WheelZoomOptions) {
	profile = "GuiDefaultProfile";
	horizSizing = "center";
	vertSizing = "center";
	position = "0 0";
	extent = "235 100";
	visible = "1";
	new ShellFieldCtrl() {
		profile = "ShellFieldProfile";
		position = "0 0";
		extent = "235 100";
		visible = "1";
		new ShellToggleButton() {
			profile = "ShellRadioProfile";
			position = "5 5";
			extent = "220 20";
			visible = "1";
			variable = "$WheelZoom::invertzoom";
			text = "Invert Zoom";
		};
		new ShellBitmapButton() {
			profile = "ShellButtonProfile";
			horizSizing = "center";
			position = "0 55";
			extent = "82 38";
			visible = "1";
			command = "WZSaveSettings();";
			text = "SAVE";
		};
	};
};